import { PhantomTypeParameter } from './Primitive/PhantomTypeParameter';
import { Cons, AnyList, Head, Tail } from './Promoted/List';
import { HKT } from './Primitive/HKT';
import { Stuck } from './Primitive/Stuck';
import { DeriveGeneric, UnInitialized } from './Primitive/UnInitialized';
import { If } from './Promoted/Bool';
import { Eq } from './Promoted/Eq';
declare type _OpenRecord<record> = object & PhantomTypeParameter<'OpenRecord/record', record>;
export interface OpenRecord<record> extends _OpenRecord<record> {
}
export declare type PropertyKey = keyof any;
export declare const empty: OpenRecord<[]>;
export declare function unsafeMakeOpenRecord<record>(internal: object): OpenRecord<record>;
interface _IsMember extends HKT {
    result: this['param'] extends [infer key, infer record] ? key extends PropertyKey ? {
        base: false;
        recursiveStep: Head<record> extends [infer keyOfHead, infer _] ? Eq<[key, keyOfHead]> extends true ? true : IsMember<[key, Tail<record>]> : Stuck;
    }[record extends [] ? 'base' : 'recursiveStep'] : Stuck : Stuck;
}
export declare type IsMember<param = UnInitialized> = DeriveGeneric<_IsMember, param>;
export declare function insert<record extends AnyList, key extends PropertyKey, value extends If<[IsMember<[key, record]>, never, unknown]>>(key: key, value: value, openRecord: OpenRecord<record>): OpenRecord<Cons<[[key, value], record]>>;
interface _Get extends HKT {
    result: this['param'] extends [infer key, infer record] ? key extends PropertyKey ? {
        base: never;
        recursiveStep: Head<record> extends [infer keyOfHead, infer value] ? Eq<[key, keyOfHead]> extends true ? value : Get<[key, Tail<record>]> : Stuck;
    }[record extends [] ? 'base' : 'recursiveStep'] : Stuck : Stuck;
}
declare type Get<param = UnInitialized> = DeriveGeneric<_Get, param>;
export declare function get<record extends AnyList, key extends PropertyKey>(key: key, record: OpenRecord<record>): Get<[key, record]>;
interface _Set extends HKT {
    result: this['param'] extends [infer key, infer value, infer record] ? key extends PropertyKey ? {
        base: never;
        recursiveStep: Head<record> extends [infer keyOfHead, infer _] ? Eq<[key, keyOfHead]> extends true ? OpenRecord<Cons<[[key, value], Tail<record>]>> : Set<[key, value, Tail<record>]> : Stuck;
    }[record extends [] ? 'base' : 'recursiveStep'] : Stuck : Stuck;
}
declare type Set<param = UnInitialized> = DeriveGeneric<_Set, param>;
export declare function set<record extends AnyList, key extends PropertyKey, value extends If<[IsMember<[key, record]>, unknown, never]>>(key: key, value: value, openRecord: OpenRecord<record>): Set<[key, value, record]>;
export declare function modify<record extends AnyList, key extends PropertyKey, R>(key: key, f: (x: Get<[key, record]>) => R, openRecord: OpenRecord<record>): Set<[key, R, record]>;
export {};
